//////// Standard Header file for the SX28AC device ////////
#device SX28AC
#nolist
/////////////////////////////// I/O definitions for INPUT() and OUTPUT_xxx()
#define PIN_A0  40
#define PIN_A1  41
#define PIN_A2  42
#define PIN_A3  43

#define PIN_B0  48
#define PIN_B1  49
#define PIN_B2  50
#define PIN_B3  51
#define PIN_B4  52
#define PIN_B5  53
#define PIN_B6  54
#define PIN_B7  55

#define PIN_C0  56
#define PIN_C1  57
#define PIN_C2  58
#define PIN_C3  59
#define PIN_C4  60
#define PIN_C5  61
#define PIN_C6  62
#define PIN_C7  63

/////////////////////////////// Useful defines
#define FALSE 0
#define TRUE 1

#define BYTE int
#define BOOLEAN short int

#define getc getch
#define getchar getch
#define puts(s) {printf(s); putchar(13); putchar(10);}
#define putc putchar

/////////////////////////////// Constants used for RESTART_CAUSE()
#define WDT_FROM_SLEEP  0
#define WDT_TIMEOUT     8
#define MCLR_FROM_SLEEP 16
#define NORMAL_POWER_UP 24
/////////////////////////////// Constants used for SETUP_COUNTERS()
#define RTCC_FILE10     128
#define RTCC_INT        64
#define RTCC_NOINT      0
#define RTCC_EXT_L_TO_H 32
#define RTCC_EXT_H_TO_L 48
#define RTCC_INTERNAL   0
#define RTCC_DIV_2      0
#define RTCC_DIV_4      1
#define RTCC_DIV_8      2
#define RTCC_DIV_16     3
#define RTCC_DIV_32     4
#define RTCC_DIV_64     5
#define RTCC_DIV_128    6
#define RTCC_DIV_256    7

#define WDT_18MS        8
#define WDT_36MS        9
#define WDT_72MS       10
#define WDT_144MS      11
#define WDT_288MS      12
#define WDT_576MS      13
#define WDT_1152MS     14
#define WDT_2304MS     15
#define L_TO_H              0x40
#define H_TO_L                 0

#define DISABLE_PULLUPS            0x40  // for 508 and 509 only
#define DISABLE_WAKEUP_ON_CHANGE   0x80  // for 508 and 509 only
#define PIN_CHANGE_FROM_SLEEP      0x90  // for 508 and 509 only



////////////////////////////// Constants used in set_mode_x()

#define mOUTPUT 0
#define mTTLIN  13
#define mCMOSIN 9
#define mSTIN   1
#define mPULLUP 2        // May be OR'ed with mTTLIN, mCMOSIN or mSTIN

////////////////////////////// Constants used in read_comp()

#define COMP_DISABLE 0x80
#define COMP_ENABLE  0
#define COMP_RB0     0x40    // May be OR'ed with COMP_ENABLE

////////////////////////////// Constants used in setup_miwu()

#define miwuL2H 0
#define miwuH2L 0x20
#define miwuOFF 0x10

////////////////////////////// Constants used in setup_timer_x()

    /// Modes
#define CAPT_INT 0x2000
#define COMP_INT 0x0800
#define OVFL_INT 0x0100
#define CAPT_L2H 0x0040
#define CAPT_H2L 0x0000
#define EXT_L2H  0x0020
#define EXT_H2L  0x0000
#define tSW      0x0000
#define tPWM     0x0001
#define tCC      0x0002
#define tEXT     0x0003
    /// Prescale
#define DIV_BY_1  0x0000
#define DIV_BY_2  0x0004
#define DIV_BY_4  0x0008
#define DIV_BY_8  0x000C
#define DIV_BY_16 0x0010
#define DIV_BY_32 0x0014
#define DIV_BY_64 0x0018
#define DIV_BY_128 0x001C

/////////////////////////////// More Constants used for SETUP_COUNTERS()

#define INT_RTCC   0x40

#list
