/////////////////////////////////////////////////////////////////////////
////                          EX_DEC.C                               ////
////                                                                 ////
////  This program shows how to display a LONG INT in  a fixed       ////
////  point format.                                                  ////
////                                                                 ////
/////////////////////////////////////////////////////////////////////////
////        (C) Copyright 1996,1997 Custom Computer Services            ////
//// This source code may only be used by licensed users of the CCS C   ////
//// compiler.  This source code may only be distributed to other       ////
//// licensed users of the CCS C compiler.  No other use, reproduction  ////
//// or distribution is permitted without written permission.           ////
//// Derivative programs created using this software in object code     ////
//// form are not restricted in any way.                                ////
////////////////////////////////////////////////////////////////////////////

#include <SX52BD.H>
#include "atd_emu.h"

#fuses HS,NOWDT,NOPROTECT

#use delay(clock=16000000)
#use rs232(baud=19200, xmit=PIN_A3, rcv=PIN_A2)

#include <INPUT.C>

void print_fp_2(long int value) {
   byte i,digit;
   long int divisor;

   divisor=10000;
   for(i=0;i<5;++i) {
      digit = value/divisor;
      value-=digit*divisor;
      divisor/=10;
      putc(digit+'0');
      if(i==2)
        putc('.');
   }
}

void print_as_volts(long int value) {    // This function shows how to
   byte i,digit;                         // display a fixed point number.
   long int divisor;                     // In this example we assume that
                                         // 0xffff is 5 volts

   divisor=13107;         // 65535 / 5
   for(i=0;i<5;++i) {
      digit = value/divisor;
      value-=digit*divisor;
      divisor/=10;
      putc(digit+'0');
      if(i==0)
        putc('.');
   }
}



main() {
   long int value;

   set_mode_a(mTTLIN,mTTLIN,mTTLIN,mTTLIN,mOUTPUT,mTTLIN,mTTLIN,mTTLIN);

   do {
      printf("\r\n\nHex value: ");
      value=gethex();
      value=value<<8|gethex();

      printf("\r\nAs dollers:  ");
      print_fp_2(value);

      printf("\r\nAs Volts:  ");
      print_as_volts(value);

   } while (TRUE);
}
