/////////////////////////////////////////////////////////////////////////
////                         EX_EXPIO.C                               ////
////                                                                  ////
////     This program shows how to use the 74165.C and 74595.C        ////
////  libraries for extended input and output.                        ////
////                                                                  ////
////     When button 1 is pushed, LED 1 will toggle green.  Button    ////
////  2 will toggle LED 2.  However, when both buttons are pushed,    ////
////  LED 3 will toggle green.                                        ////
////                                                                  ////
////  Configure the Scenix Demo Board as follows:                     ////
////               74165 pin    Demo Board                            ////
////                  1            PIN_B3                             ////
////                  2            PIN_B4                             ////
////                  3            gnd                                ////
////                  4            gnd                                ////
////                  5            gnd                                ////
////                  6            gnd                                ////
////                  8            gnd                                ////
////                  9            PIN_B5                             ////
////                  11           Button 1                           ////
////                  12           Button 2                           ////
////                  13           gnd                                ////
////                  14           gnd                                ////
////                  15           gnd                                ////
////                  16           +5V                                ////
////                                                                  ////
////               74595 pin    Protoboard                            ////
////                  1            LED 2                              ////
////                  2            LED 3                              ////
////                  3            gnd                                ////
////                  4            gnd                                ////
////                  5            gnd                                ////
////                  6            gnd                                ////
////                  7            gnd                                ////
////                  8            gnd                                ////
////                  10           +5V                                ////
////                  11           PIN_B1                             ////
////                  12           PIN_B0                             ////
////                  13           gnd                                ////
////                  14           PIN_B2                             ////
////                  15           LED 1                              ////
////                  16           +5V                                ////
////                                                                  ////
//////////////////////////////////////////////////////////////////////////
////        (C) Copyright 1996,1997 Custom Computer Services          ////
//// This source code may only be used by licensed users of the CCS C ////
//// compiler.  This source code may only be distributed to other     ////
//// licensed users of the CCS C compiler.  No other use, reproduction////
//// or distribution is permitted without written permission.         ////
//// Derivative programs created using this software in object code   ////
//// form are not restricted in any way.                              ////
//////////////////////////////////////////////////////////////////////////

#include <SX28AC.H>
#include "atd_emu.h"

#fuses HS,NOWDT,NOPROTECT

#use delay(clock=16000000)

#include "74595.C"
#include "74165.C"

main() {
   byte data;

   set_mode_a(mTTLIN,mTTLIN,mTTLIN,mTTLIN,mOUTPUT,mTTLIN,mTTLIN,mTTLIN);
   set_mode_b(mOUTPUT,mOUTPUT,mTTLIN,mOUTPUT,mOUTPUT,mOUTPUT,mOUTPUT,mOUTPUT);

   do {
      read_expanded_inputs (&data);

      data |= 0xF8;                           //Force the unused input bits on
      data -= (!(data&0x01)&!(data&0x02))<<2; //Turn on bit 2 it both inputs are
                                              //toggled
      write_expanded_outputs (&data);
   } while (TRUE);
}
